<?php

/* options.php: Page for users to change personal settings
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: options.php,v 1.104 2003/11/28 16:37:53 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'options');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get unseen status */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);


/* profiles */
$current_count = $_SESSION['settings']['profile_count'];

/* check for special folders */
hm_check_folders();

/* remove profile */
foreach ($_POST as $name => $val) {
    if (substr($name, 0, 14) == 'remove_profile') {
        $index = substr($name, 15);
        array_splice($_SESSION['profiles'], $index, 1);
        $current_count--;
        $_SESSION['settings']['profile_count'] = $current_count;
        hm_write_settings($_SESSION['user'], $config['settings_dir'], $index);
        $_SESSION['notices'][] = $str[249];
        break;
    }
}
/* add profile */
if (isset($hm_input['add_profile'])) {
    $_SESSION['profiles'][] = array('sig' => '', 'from_name' => '', 'from_address' => '');
    $current_count++;
    $_SESSION['settings']['profile_count'] = $current_count;
    hm_write_settings($_SESSION['user'], $config['settings_dir']);
    $_SESSION['notices'][] = $str[248];
}

/* update settings */
if (isset($hm_input['submit']) && $hm_input['submit'] == $str[103]) {

    /* set css value */
    $_SESSION['settings']['css_file'] = $hm_input['css_selection'];

    /* date format setting */
    $_SESSION['settings']['date_format'] = $hm_input['date_selection'];

    /* time format setting */
    $_SESSION['settings']['time_format'] = $hm_input['time_selection'];

    /* combine time and date */
    if ($hm_input['date_selection'] == 'r') {
        $_SESSION['settings']['date_string'] = 'r';
    }
    else {
        $_SESSION['settings']['date_string'] = $hm_input['time_selection'].' '.
                                               $hm_input['date_selection'];
    }

    /* language setting */
    $_SESSION['settings']['lang'] = $hm_input['lang_selection'];
    $str = hm_translate($hm_input['lang_selection'], $lang_options);
    if (isset($config['disable_utf8'])) {
        if ($config['disable_utf8'] != 'true') {
            $_SESSION['str']['charset'] = 'UTF-8';
        }
    }
    else {
        $_SESSION['str']['charset'] = 'UTF-8';
    }
    if (isset($config['disable_utf8'])) {
        if ($config['disable_utf8'] != 'true') {
            foreach ($str as $key => $value) {
                if (is_array($value)) {
                    foreach ($value as $k => $v) {
                        $_SESSION['str'][$key][$k] = utf8_encode($v);
                    }
                }
                else {
                    $_SESSION['str'][$key] = utf8_encode($value);
                }
            }
            $_SESSION['str']['charset'] = 'UTF-8';
        }
        else {
            $_SESSION['str'] = $str;
        }
    }
    else {
        $str['charset'] = 'UTF-8';
        foreach ($str as $key => $value) {
            if (is_array($value)) {
                foreach ($value as $k => $v) {
                    $_SESSION['str'][$key][$k] = utf8_encode($v);
                }
            }
            else {
                $_SESSION['str'][$key] = utf8_encode($value);
            }
        }
        $_SESSION['str']['charset'] = 'UTF-8';
    }
    $str = $_SESSION['str'];

    /* display settings */

    /* message per page */
    if (isset($hm_input['page_count'])) {
        if ($hm_input['page_count'] > 250) {
            $hm_input['page_count'] = 250;
        }
        $_SESSION['settings']['page_count'] = $hm_input['page_count'];
        $_SESSION['sort_data'] = array();
        unset($_SESSION['sort_data']);
    }
    else {
        $_SESSION['settings']['page_count'] = 20;
    }

    /* wrap length on message view */
    if (isset($hm_input['read_wrap'])) {
        $_SESSION['settings']['read_wrap'] = $hm_input['read_wrap'];
    }
    else {
        $_SESSION['settings']['read_wrap'] = 80;
    }

    /* "New" folder refresh setting, defaulting to 1 min refresh rate */
    if (isset($hm_input['refresh_new'])) {
        $_SESSION['settings']['refresh_new'] = $hm_input['refresh_new'];
    } 
    else {
        $_SESSION['settings']['refresh_new'] = 1;
    }

    /* sent folder */
    if (isset($hm_input['sent_on']) && $hm_input['sent_on'] == 1) {
        $_SESSION['settings']['sent_folder'] = $hm_input['sent_folder'];
    }
    elseif (isset($_SESSION['settings']['sent_folder'])) {
        unset($_SESSION['settings']['sent_folder']);
    }

    /* trash folder */
    if (isset($hm_input['trash_on']) && $hm_input['trash_on'] == 1) {
        $_SESSION['settings']['trash_folder'] = $hm_input['trash_folder'];
    }
    elseif (isset($_SESSION['settings']['trash_folder'])) {
        unset($_SESSION['settings']['trash_folder']);
    }

    /* drafts folder */
    if (isset($hm_input['drafts_on']) && $hm_input['drafts_on'] == 1) {
        $_SESSION['settings']['drafts_folder'] = $hm_input['drafts_folder'];
    }
    elseif (isset($_SESSION['settings']['drafts_folder'])) {
        unset($_SESSION['settings']['drafts_folder']);
    }
  
    /* start page */
    if (isset($hm_input['start_page'])) {
        $_SESSION['settings']['start_page'] = $hm_input['start_page'];
    }
    else {
        $_SESSION['settings']['start_page'] = 'mailbox.php';
    }

    /* update profiles */
    for ($i=0;$i<$current_count;$i++) {
        $_SESSION['profiles'][$i]['sig'] = $hm_input['sig_'.$i];
        $_SESSION['profiles'][$i]['from_name'] = 
                    htmlspecialchars(stripslashes(str_replace(array('<', '>'), '', 
                    $hm_input['from_name_'.$i])), ENT_QUOTES, $str['charset']);
        $_SESSION['profiles'][$i]['from_address'] = 
                    htmlspecialchars(stripslashes(str_replace(array('<', '>'), '', 
                    $hm_input['from_address_'.$i])), ENT_QUOTES, $str['charset']);
    }

    /* filter level */
    $level = 1;
    if (isset($hm_input['filter_links']) && $hm_input['filter_links'] == 1) {
        $level = 3;
    }
    if (isset($hm_input['filter_images']) && $hm_input['filter_images'] == 1) {
        if ($level > 1) {
            $level = 4;
        }
        else{
            $level = 2;
        }
    }
    $_SESSION['settings']['filter_level'] = $level;
 
    /* simple mode */
    if (isset($hm_input['simple']) && $hm_input['simple'] == 1) {
        $_SESSION['settings']['simple'] = 'true';
    }
    else {
        $_SESSION['settings']['simple'] = 'false';
    }
    
    /* clickable http links */
    if (isset($hm_input['click_links']) && $hm_input['click_links'] == 1) {
        $_SESSION['settings']['click_links'] = 'true';
    }
    else {
        $_SESSION['settings']['click_links'] = 'false';
    }
    /* clickable email links */
    if (isset($hm_input['click_email']) && $hm_input['click_email'] == 1) {
        $_SESSION['settings']['click_email'] = 'true';
    }
    else {
        $_SESSION['settings']['click_email'] = 'false';
    }
         
    /* clean line wrapping */
    if (isset($hm_input['wrap_clean']) && $hm_input['wrap_clean'] == 1) {
        $_SESSION['settings']['wrap_clean'] = 'true';
    }
    else {
        $_SESSION['settings']['wrap_clean'] = 'false';
    }
    /* html mail display */
    if (isset($hm_input['html_only']) && $hm_input['html_only'] == 1) {
        $_SESSION['settings']['html_only'] = 'true';
    }
    else {
        $_SESSION['settings']['html_only'] = 'false';
    }

    /* font family for message text */
    if (isset($hm_input['font_type'])) {
        $_SESSION['settings']['font_type'] = $hm_input['font_type'];
    }
    else {   
        $_SESSION['settings']['font_type'] = 'monospace';
    }
    /* write the settings to the user's setting file */
    hm_write_settings($_SESSION['user'], $config['settings_dir']);
    $_SESSION['notices'][] = $str[118];
}

/* check for simple option and set flag */
$simple_dsp = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple_dsp = true;
}

$settings = $_SESSION['settings'];
if (isset($settings['page_count']) && $settings['page_count'] > 0) {
    $page_count = $settings['page_count'];
}
else {
    $page_count = 20;
}
if (isset($settings['read_wrap']) && $settings['read_wrap'] > 0) {
    $read_wrap = $settings['read_wrap'];
}
else {
    $read_wrap = 80;
}

/* available languages */
if (!isset($settings['lang'])) {
    if (isset($_SESSION['config']['default_lang'])) {
        $settings['lang'] = $_SESSION['config']['default_lang'];
    }
    else {
        $settings['lang'] = 'en_US';
    }
}
$langs = array();
if ($dir = @opendir("../lang")) {
  while (($file = readdir($dir)) !== false) {
    if (preg_match("/\.php$/", $file) && $file != 'index.php' && 
        $file != 'lang_index.php') {
        $langs[] = str_replace('.php', '', $file);
    } 
  }  
  closedir($dir);
}
$lcount = count($langs);

/* select CSS */
if (!isset($settings['css_file'])) {
    $settings['css_file'] = 'default.css';
}
$css_files = array();
if ($dir = @opendir("../themes")) {
  while (($file = readdir($dir)) !== false) {
    if (preg_match("/\.css$/", $file)) {
        $css_files[] = $file;
    } 
  }  
  closedir($dir);
}
$count = count($css_files);

/* toolbar */

hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, $str[12]);

/* options form */
echo '<form action="options.php" method="post">
<input type="hidden" name="id" value="',$hm_input['id'],'">
<input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
<br>',"\n";

if (!$simple_dsp) {
    $opt_start = '         <tr class="tables1">
            <td width="65%" nowrap>';
    $opt_mid = '            </td>
            <td nowrap>';
    $opt_close = '            </td>
         </tr>'."\n";
    echo '<table align="center" cellpadding="4" cellspacing="2">
   <tr>
      <td align="center" rowspan="2" valign="top">
      <table align="center" width="50%" cellspacing="1" cellpadding="2" class="tables1">
         <tr class="tables2">
            <td align="center" colspan="2">
            ',$str[98],'
            </td>
         </tr>
         <tr>
            <td align="center" colspan="2">
            <br>
            </td>
         </tr>
         <tr class="tables1">
            <td width="65%" nowrap>
            &nbsp;&nbsp;',$str[105],':
            </td>
            <td>',"\n";
}
else {
    $opt_start = "\n".'<br>';
    $opt_mid = '&nbsp;';
    $opt_close = '';
    echo '<br>&nbsp;&nbsp;',$str[105],': ';
}
/* theme selection */
echo '            <select name="css_selection">',"\n";
for ($n=0;$n<$count;$n++) {
    echo '            <option class="option2" value="',$css_files[$n],'" ';
    if ($settings['css_file'] == $css_files[$n]) {
        echo 'SELECTED ';
    }
    echo ">",str_replace('.css', '', $css_files[$n]),"</option>\n";
}

/* language selection */
echo '            </select>',"\n",
      $opt_close,
      $opt_start,'
            &nbsp;&nbsp;',$str[215],':',"\n",$opt_mid,'
            <select name="lang_selection">',"\n";
for ($n=0;$n<$lcount;$n++) {
    if (isset($lang_options[$langs[$n]])) {
    echo '            <option class="option2" value="',$langs[$n],'" ';
    if ($settings['lang'] == $langs[$n]) {
        echo 'SELECTED ';
    }
    echo ">",$str[$lang_options[$langs[$n]]],"</option>\n";
    }
}

/* time format */
$time_types = array('12:00:00' => 'g:i:s a', '24:00:00' => 'G:i:s',
                    '12:00'    => 'g:i a',   '24:00'    => 'G:i');
echo '            </select>',"\n",
      $opt_close,
      $opt_start,'
            &nbsp;&nbsp;',$str[264],':',"\n",$opt_mid,'
            <select name="time_selection">',"\n";
foreach($time_types as $name => $val) {
    echo '            <option class="option2" value="',$val,'" ';
    if (isset($settings['time_format']) && $settings['time_format'] == $val) {
        echo 'SELECTED ';
    }
    echo ">",$name,"</option>\n";
}

/* date format */
$date_types = array('mm/dd/yy'     => 'm/d/y',  'mm/dd/yyyy'     => 'm/d/Y',
                    'mm-dd-yy'     => 'm-d-y',  'mm-dd-yyyy'     => 'm/d/Y',
                    'mon dd, yyyy' => 'M j, Y', 'mon dd, yy'     => 'M j, y',
                    'mon dd'       => 'M j',    'month dd, yyyy' => 'F d, Y',
                    'month dd, yy' => 'F d, y', 'rfc822'         => 'r',
                    'dd/mm/yyyy'   => 'd/m/Y',  'dd/mm/yy'       => 'd/m/y');

echo '            </select>',"\n",
      $opt_close,
      $opt_start,'
            &nbsp;&nbsp;',$str[263],':',"\n",$opt_mid,'
            <select name="date_selection">',"\n";
foreach($date_types as $name => $val) {
    echo '            <option class="option2" value="',$val,'" ';
    if (isset($settings['date_format']) && $settings['date_format'] == $val) {
        echo 'SELECTED ';
    }
    echo ">",$name,"</option>\n";
}
/* font type */
echo '            </select>',"\n",
      $opt_close,
      $opt_start,'
            &nbsp;&nbsp;',$str[107],':',"\n",$opt_mid,'
            <select name="font_type">',"\n";
$fonts = array('serif', 'sans-serif', 'cursive', 'fantasy', 'monospace');
if (isset($_SESSION['settings']['font_type'])) {
    $current_font = $_SESSION['settings']['font_type'];
}
else {
    $current_font = 'monospace';
}
foreach ($fonts as $font) {
    echo '               <option class="option2" ';
    if ($current_font == $font) {
        echo 'SELECTED ';
    }
    echo 'value="',$font,'">',$font,'</option>',"\n";
}

/* new page refresh rate */
echo '            </select>&nbsp;&nbsp;',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[108],':',"\n",
     $opt_mid,' 
            <select name="refresh_new">',"\n";
$times = array(0,1,2,3,5,10,15,20,30);
if (isset($_SESSION['settings']['refresh_new'])) {
    $cur_set = $_SESSION['settings']['refresh_new'];
}
else {
    $cur_set = 1;
}
foreach ($times as $value) {
    if ($value != 1) {
        $mins = $str[120];
    }
    else {
        $mins = $str[119];
    }
    $mins = $value . ' ' . $mins;
    if ($value == 0) {
        $mins = $str[106];
    }
    echo "               <option class=\"option2\" value=\"$value\"";
    if ($cur_set == $value) {
        echo " SELECTED ";
    }
    echo "> $mins </option>\n";
}

/* start page */
$start_pgs = array($str[220]  => 'mailbox.php',
                   $str[10]   => 'new.php',
                   $str[15]   => 'compose.php',
                   $str[12]   => 'options.php',
                   $str[13]   => 'folders.php',
                   $str[14]   => 'contacts.php',
                   $str[11]   => 'search.php');

if (isset($_SESSION['settings']['start_page'])) {
    $sp = $_SESSION['settings']['start_page'];
}
else {
    $sp = 'mailbox.php';
}
echo '            </select>',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[219],':',"\n",
     $opt_mid,'
            <select name="start_page">',"\n";
    foreach($start_pgs as $key => $value) {
        echo '<option ';
        if ($sp == $value) {
            echo 'SELECTED ';
        }
        echo 'value="',$value,'">',$key,'</option>',"\n";
    }
    echo "</select>",
     $opt_close,

     /* per page count for mailbox page */
     $opt_start,'
            &nbsp;&nbsp;',$str[109],':',"\n",
     $opt_mid,'
            <input type="text" size="4" name="page_count" ', 
     'value="',$page_count,'" class="text2">',"\n",
     $opt_close,

     /* wrap at length in chars for message page */
     $opt_start,'
            &nbsp;&nbsp;',$str[110],':',"\n",
     $opt_mid,'
            <input type="text" size="4" name="read_wrap" ',
     'value="',$read_wrap,'" class="text2">',"\n",
     $opt_close,

     /* clean wrapping toggle */
     $opt_start,'
            &nbsp;&nbsp;',$str[111],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="wrap_clean" ';
if (isset($_SESSION['settings']['wrap_clean']) && 
          $_SESSION['settings']['wrap_clean'] == 'true') {
    echo 'CHECKED ';
}

/* show html part toggle */
echo 'value="1">',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[235],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="html_only" ';
if (isset($_SESSION['settings']['html_only']) && 
          $_SESSION['settings']['html_only'] == 'true') {
    echo 'CHECKED ';
}

/* simple mode toggle */
echo 'value="1">',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[112],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="simple" ';
if (isset($_SESSION['settings']['simple']) && 
          $_SESSION['settings']['simple'] == 'true') {
    echo 'CHECKED ';
}
echo 'value="1">';
if (!$simple_dsp) {
    echo '      </td>
         <tr>
            <td>
            <br>
            </td>
         </tr>
      </table>
      </td>
      <td valign="top">
      <table align="center" width="100%" cellspacing="1" cellpadding="2" class="tables1">
         <tr class="tables2">
            <td colspan="2" align="center">
            ',$str[99],'
            </td>
         </tr>
         <tr>
            <td colspan="2">
            <br>
            </td>
         </tr>',"\n";
}

/* HTML links filter toggle */
echo  $opt_start,'
            &nbsp;&nbsp;',$str[113],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="filter_links" ';
if (isset($_SESSION['settings']['filter_level']) && 
          ($_SESSION['settings']['filter_level'] == 3 ||
           $_SESSION['settings']['filter_level'] == 4)) {
    echo 'CHECKED ';
}

/* HTML images filter toggle */
echo 'value="1">',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[114],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="filter_images" ';
if (isset($_SESSION['settings']['filter_level']) && 
          ($_SESSION['settings']['filter_level'] == 2 ||
           $_SESSION['settings']['filter_level'] == 4)) {
    echo 'CHECKED ';
}

/* TEXT clickable links toggle */
echo 'value="1">',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[237],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="click_links" ';
if (isset($_SESSION['settings']['click_links']) &&
          $_SESSION['settings']['click_links'] == 'true') {
    echo 'CHECKED ';
}

/* TEXT clickable email addresses toggle */
echo 'value="1">',"\n",
     $opt_close,
     $opt_start,'
            &nbsp;&nbsp;',$str[238],':',"\n",
     $opt_mid,'
            <input type="checkbox" name="click_email" ';
if (isset($_SESSION['settings']['click_email']) &&
          $_SESSION['settings']['click_email'] == 'true') {
    echo 'CHECKED ';
}
echo 'value="1">',"\n";
if (!$simple_dsp) {
    echo '            </td>
         </tr>
         <tr>
            <td colspan="2">
            <br>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>',"\n";
}

/* the folder options */
$folders = $_SESSION['folders'];
if (isset($_SESSION['settings']['sent_folder'])) {
    $current_sent = urldecode($_SESSION['settings']['sent_folder']);
}
else {
    $current_sent = 'INBOX';
}
if (isset($_SESSION['settings']['drafts_folder'])) {
    $current_drafts = urldecode($_SESSION['settings']['drafts_folder']);
}
else {
    $current_drafts = 'INBOX';
}
if (isset($_SESSION['settings']['trash_folder'])) {
    $current_trash = urldecode($_SESSION['settings']['trash_folder']);
}
else {
    $current_trash = 'INBOX';
}
if (!$simple_dsp) {
echo '  
      <td align="center" valign="bottom">
      <table align="center" width="100%" cellspacing="1" cellpadding="2" class="tables1">
         <tr class="tables2">
            <td align="center" colspan="2">
            ',$str[13],'
            </td>
         </tr>
         <tr>
            <td colspan="2">
            <br>
            </td>
         </tr>
         <tr class="tables1">
            <td>',"\n";
}
else {
    echo '<br>';
}
/* sent folder */
echo '            &nbsp;<input type="checkbox" ';
if (isset($_SESSION['settings']['sent_folder'])) {
    echo "CHECKED ";
}
echo 'name="sent_on" value="1">
            &nbsp;',$str[115],"\n";
if (!$simple_dsp) {
    echo '            </td>
            <td valign="bottom">',"\n";
}
echo '-&gt;<select name="sent_folder" class="text2">',"\n";
    hm_folder_options($current_sent, false, $simple_dsp, false);
echo '            </select>',"\n";
if (!$simple_dsp) {
    echo '            </td>
         </tr>
         <tr class="tables1">
            <td nowrap>',"\n";
}
else {
    echo '<br>';
}
/* trash folder */
echo '            &nbsp;<input type="checkbox" ';
if (isset($_SESSION['settings']['trash_folder'])) {
    echo "CHECKED ";
}
echo 'name="trash_on" value="1">
            &nbsp;',$str[116],"\n";
if (!$simple_dsp) {
echo '            </td>
            <td valign="bottom">',"\n";
}
echo '-&gt;<select name="trash_folder" class="text2">',"\n";
    hm_folder_options($current_trash, false, $simple_dsp, false);
echo '            </select>',"\n";
if (!$simple_dsp) {
    echo '            </td>
         </tr>
         <tr class="tables1">
            <td nowrap>',"\n";
}
else {
    echo '<br>';
}
/* drafts folder */

echo '            &nbsp;<input type="checkbox" ';
if (isset($_SESSION['settings']['drafts_folder'])) {
    echo "CHECKED ";
}
echo 'name="drafts_on" value="1">
            &nbsp;',$str[117],"\n";
if (!$simple_dsp) {
echo '            </td>
            <td valign="bottom" nowrap>',"\n";
}
echo '-&gt;<select name="drafts_folder" class="text2">',"\n";
    hm_folder_options($current_drafts, false, $simple_dsp, false);
echo '            </select>&nbsp;',"\n";
if (!$simple_dsp) {
    echo '            </td>
         </tr>
         <tr>
            <td colspan="2">
            <br>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td align="center" colspan="2">
      <br><input type="submit" class="button1" value="',$str[103],'" name="submit">
      <br><br>
      </td>
   </tr>',"\n";
}

/* profiles */
if(!$simple_dsp) {
    for ($i=0;$i<$current_count;$i++) {
    $current_profile = $_SESSION['profiles'][$i];
    echo '   <tr>
      <td align="center" colspan="2">
      <table width="100%" cellpadding="2" cellspacing="1" class="tables1">',"\n";
        echo '         <tr class="tables2">
            <td colspan="2" align="center">',"\n";
                if ($i == 0) {
                    echo $str[100],"\n";
                }
                else {
                    echo $str[104],' ',($i+1);
                }
                echo '            </td>
         </tr>
         <tr>
            <td>
            &nbsp;
            </td>
         </tr>
         <tr>
            <td valign="top" align="center" height="1%">
            ',$str[93],':<br>
            <input type="text" name="from_name_'.$i.'" class="text2" size="28" ',
            'value="',$current_profile['from_name'],'">
            </td>
            <td align="center" rowspan="2">
            ',$str[102],':<br>
            <textarea cols="60" name="sig_',$i,'" class="composetext" rows="10">',
            $current_profile['sig'],'</textarea>
            </td>
         </tr>
         <tr>
            <td valign="top" align="center">
            ',$str[101],':<br>
            <input type="text" name="from_address_',$i,'" class="text2" size="28" ',
            'value="',$current_profile['from_address'],'">
            <br><br><br><br>',"\n";
        if ($i == 0) {
            echo '            <input class="button1" type="submit" value="',$str[250],
                 '" name="add_profile">',"\n";
        }
        else {
            echo '<input class="button1" type="submit" value="',$str[251],
                 '" name="remove_profile_',$i,'">',"\n";
        }
        echo '            </td>
         </tr>
         <tr>
            <td>
            &nbsp;
            </td>
         </tr>
      </table>
      </td>
   </tr>',"\n";
    }
    echo '   <tr>
      <td  align="center" colspan="2">
      <br><input type="submit" class="button1" value="',$str[103],'" name="submit">
      </td>
   </tr>
</table>',"\n";
}
else {
    echo '<br><br>',$str[104],'<br>',"\n";
    for ($i=0;$i<$current_count;$i++) {
        $current_profile = $_SESSION['profiles'][$i];
        echo $str[93],': <input type="text" name="from_name_',$i,
             '" class="text2" size="28" value="',$current_profile['from_name'],
             '"><br> ',$str[101],': <input type="text" name="from_address_',
             $i,'" class="text2" size="28" value="',$current_profile['from_address'],
             '"><br>',$str[102],':<br><textarea cols="76" name="sig_',$i,
             '" class="composetext" ',
             'rows="10">',$current_profile['sig'],'</textarea><br>',"\n";
        if ($i == 0) {
            echo '            <input class="button1" type="submit" value="New Profile" ',
                 'name="add_profile"><br><br>',"\n";
        }
        else {
            echo '<input class="button1" type="submit" value="Remove Profile" name="remove_profile_',$i,'"><br><br>',"\n";
        }
    }
    echo '<input type="submit" class="button1" value="',$str[103],'" name="submit">',"\n";
}
echo '</form>
</body>
</html>';

hm_imap_logout($imap_stream); 

?>
